package com.yihu.jw.base.dao.article;

import com.yihu.jw.entity.hospital.article.KnowledgeArticleDO;
import com.yihu.jw.entity.hospital.article.KnowledgeArticleDeptDO;
import com.yihu.jw.entity.hospital.article.KnowledgeArticleMenuDO;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.jpa.repository.JpaRepository;

import java.util.List;

/**
 * 健康文章部门关系DAO
 * @author huangwenjie
 * @date 2019/9/18 10:03
 */
public interface KnowledgeArticleMenuDao extends JpaRepository<KnowledgeArticleMenuDO, String>, JpaSpecificationExecutor<KnowledgeArticleMenuDO> {
	
	List<KnowledgeArticleMenuDO> findByArticleId(String articleId);
	
	List<KnowledgeArticleMenuDO> findByMenuId(String menuId);
}
